import{s as _e,o as be,n as xe}from"../chunks/scheduler.f6319a2a.js";import{S as Ce,i as $e,g as o,s as a,r as Q,A as Te,h as i,f as n,c as l,j as we,u as X,x as c,k as K,y as Le,a as s,v as Z,d as ee,t as te,w as ne}from"../chunks/index.85aa684c.js";import{T as Me}from"../chunks/Tip.3d397a88.js";import{H as He,E as ke}from"../chunks/EditOnGithub.006048dd.js";function ye(P){let r,d='Read <a href="https://huggingface.co/blog/open-source-llms-as-agents" rel="nofollow">Open-source LLMs as LangChain Agents</a> blog post to learn more about multi-step agents.';return{c(){r=o("p"),r.innerHTML=d},l(p){r=i(p,"P",{"data-svelte-h":!0}),c(r)!=="svelte-wdq32h"&&(r.innerHTML=d)},m(p,y){s(p,r,y)},p:xe,d(p){p&&n(r)}}}function Ae(P){let r,d,p,y,u,S,h,se='The ReAct framework (<a href="https://huggingface.co/papers/2210.03629" rel="nofollow">Yao et al., 2022</a>) is currently the main approach to building agents.',E,v,ae="The name is based on the concatenation of two words, “Reason” and “Act.” Indeed, agents following this architecture will solve their task in as many steps as needed, each step consisting of a Reasoning step, then an Action step where it formulates tool calls that will bring it closer to solving the task at hand.",z,w,le="All agents in <code>smolagents</code> are based on singular <code>MultiStepAgent</code> class, which is an abstraction of ReAct framework.",R,_,oe="On a basic level, this class performs actions on a cycle of following steps, where existing variables and knowledge is incorporated into the agent logs like below:",O,b,ie="Initialization: the system prompt is stored in a <code>SystemPromptStep</code>, and the user query is logged into a <code>TaskStep</code> .",q,x,re="While loop (ReAct loop):",j,C,ce='<li>Use <code>agent.write_memory_to_messages()</code> to write the agent logs into a list of LLM-readable <a href="https://huggingface.co/docs/transformers/en/chat_templating" rel="nofollow">chat messages</a>.</li> <li>Send these messages to a <code>Model</code> object to get its completion. Parse the completion to get the action (a JSON blob for <code>ToolCallingAgent</code>, a code snippet for <code>CodeAgent</code>).</li> <li>Execute the action and logs result into memory (an <code>ActionStep</code>).</li> <li>At the end of each step, we run all callback functions defined in <code>agent.step_callbacks</code> .</li>',I,$,pe="Optionally, when planning is activated, a plan can be periodically revised and stored in a <code>PlanningStep</code> . This includes feeding facts about the task at hand to the memory.",U,T,fe="For a <code>CodeAgent</code>, it looks like the figure below.",W,f,me='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/smolagents/codeagent_docs.png"/>',D,L,ge="Here is a video overview of how that works:",J,m,de='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/Agent_ManimCE.gif"/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/Agent_ManimCE.gif"/>',N,M,ue="We implement two versions of agents:",V,H,he='<li><a href="/docs/smolagents/v1.10.0/en/reference/agents#smolagents.CodeAgent">CodeAgent</a> is the preferred type of agent: it generates its tool calls as blobs of code.</li> <li><a href="/docs/smolagents/v1.10.0/en/reference/agents#smolagents.ToolCallingAgent">ToolCallingAgent</a> generates tool calls as a JSON in its output, as is commonly done in agentic frameworks. We incorporate this option because it can be useful in some narrow cases where you can do fine with only one tool call per step: for instance, for web browsing, you need to wait after each action on the page to monitor how the page changes.</li>',F,g,G,k,Y,A,B;return u=new He({props:{title:"How do multi-step agents work?",local:"how-do-multi-step-agents-work",headingTag:"h1"}}),g=new Me({props:{warning:!1,$$slots:{default:[ye]},$$scope:{ctx:P}}}),k=new ke({props:{source:"https://github.com/huggingface/smolagents/blob/main/docs/source/en/conceptual_guides/react.mdx"}}),{c(){r=o("meta"),d=a(),p=o("p"),y=a(),Q(u.$$.fragment),S=a(),h=o("p"),h.innerHTML=se,E=a(),v=o("p"),v.textContent=ae,z=a(),w=o("p"),w.innerHTML=le,R=a(),_=o("p"),_.textContent=oe,O=a(),b=o("p"),b.innerHTML=ie,q=a(),x=o("p"),x.textContent=re,j=a(),C=o("ul"),C.innerHTML=ce,I=a(),$=o("p"),$.innerHTML=pe,U=a(),T=o("p"),T.innerHTML=fe,W=a(),f=o("div"),f.innerHTML=me,D=a(),L=o("p"),L.textContent=ge,J=a(),m=o("div"),m.innerHTML=de,N=a(),M=o("p"),M.textContent=ue,V=a(),H=o("ul"),H.innerHTML=he,F=a(),Q(g.$$.fragment),G=a(),Q(k.$$.fragment),Y=a(),A=o("p"),this.h()},l(e){const t=Te("svelte-u9bgzb",document.head);r=i(t,"META",{name:!0,content:!0}),t.forEach(n),d=l(e),p=i(e,"P",{}),we(p).forEach(n),y=l(e),X(u.$$.fragment,e),S=l(e),h=i(e,"P",{"data-svelte-h":!0}),c(h)!=="svelte-nsa9lf"&&(h.innerHTML=se),E=l(e),v=i(e,"P",{"data-svelte-h":!0}),c(v)!=="svelte-2021n9"&&(v.textContent=ae),z=l(e),w=i(e,"P",{"data-svelte-h":!0}),c(w)!=="svelte-zl5ssw"&&(w.innerHTML=le),R=l(e),_=i(e,"P",{"data-svelte-h":!0}),c(_)!=="svelte-1chrp8z"&&(_.textContent=oe),O=l(e),b=i(e,"P",{"data-svelte-h":!0}),c(b)!=="svelte-3wnwgb"&&(b.innerHTML=ie),q=l(e),x=i(e,"P",{"data-svelte-h":!0}),c(x)!=="svelte-1qs057z"&&(x.textContent=re),j=l(e),C=i(e,"UL",{"data-svelte-h":!0}),c(C)!=="svelte-1xb8sbm"&&(C.innerHTML=ce),I=l(e),$=i(e,"P",{"data-svelte-h":!0}),c($)!=="svelte-2uzzav"&&($.innerHTML=pe),U=l(e),T=i(e,"P",{"data-svelte-h":!0}),c(T)!=="svelte-m3d6g5"&&(T.innerHTML=fe),W=l(e),f=i(e,"DIV",{class:!0,"data-svelte-h":!0}),c(f)!=="svelte-1hb194n"&&(f.innerHTML=me),D=l(e),L=i(e,"P",{"data-svelte-h":!0}),c(L)!=="svelte-b9ve8f"&&(L.textContent=ge),J=l(e),m=i(e,"DIV",{class:!0,"data-svelte-h":!0}),c(m)!=="svelte-4ra9xq"&&(m.innerHTML=de),N=l(e),M=i(e,"P",{"data-svelte-h":!0}),c(M)!=="svelte-1gk13er"&&(M.textContent=ue),V=l(e),H=i(e,"UL",{"data-svelte-h":!0}),c(H)!=="svelte-1fcz6re"&&(H.innerHTML=he),F=l(e),X(g.$$.fragment,e),G=l(e),X(k.$$.fragment,e),Y=l(e),A=i(e,"P",{}),we(A).forEach(n),this.h()},h(){K(r,"name","hf:doc:metadata"),K(r,"content",Pe),K(f,"class","flex justify-center"),K(m,"class","flex justify-center")},m(e,t){Le(document.head,r),s(e,d,t),s(e,p,t),s(e,y,t),Z(u,e,t),s(e,S,t),s(e,h,t),s(e,E,t),s(e,v,t),s(e,z,t),s(e,w,t),s(e,R,t),s(e,_,t),s(e,O,t),s(e,b,t),s(e,q,t),s(e,x,t),s(e,j,t),s(e,C,t),s(e,I,t),s(e,$,t),s(e,U,t),s(e,T,t),s(e,W,t),s(e,f,t),s(e,D,t),s(e,L,t),s(e,J,t),s(e,m,t),s(e,N,t),s(e,M,t),s(e,V,t),s(e,H,t),s(e,F,t),Z(g,e,t),s(e,G,t),Z(k,e,t),s(e,Y,t),s(e,A,t),B=!0},p(e,[t]){const ve={};t&2&&(ve.$$scope={dirty:t,ctx:e}),g.$set(ve)},i(e){B||(ee(u.$$.fragment,e),ee(g.$$.fragment,e),ee(k.$$.fragment,e),B=!0)},o(e){te(u.$$.fragment,e),te(g.$$.fragment,e),te(k.$$.fragment,e),B=!1},d(e){e&&(n(d),n(p),n(y),n(S),n(h),n(E),n(v),n(z),n(w),n(R),n(_),n(O),n(b),n(q),n(x),n(j),n(C),n(I),n($),n(U),n(T),n(W),n(f),n(D),n(L),n(J),n(m),n(N),n(M),n(V),n(H),n(F),n(G),n(Y),n(A)),n(r),ne(u,e),ne(g,e),ne(k,e)}}}const Pe='{"title":"How do multi-step agents work?","local":"how-do-multi-step-agents-work","sections":[],"depth":1}';function Se(P){return be(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qe extends Ce{constructor(r){super(),$e(this,r,Se,Ae,_e,{})}}export{qe as component};
